function out = EP()

out{1} = @f;
out{2} = @fder;
out{3} = @testfunctions;
out{4} = @testlabels;
out{5} = [];%special processor

end
%NB note that x=[u;p(ap)];
function ansf = f(x)
    global copt;
    [u,p] = discx(x);
    ansf = copt.F(u,p);
end

function ansfder = fder(x)
    global copt;
    [u,p] = discx(x);
    ansfder = [calcjac(u,p),calcjacp(u,p,copt.ap)];
end


function labels = testlabels()
labels = ['F' 'H' 'B'];
end


function vals = testfunctions(Fx,v,eigv,varargin)
id = 0;
if nargin > 3
    id = varargin{1};
end
switch id
    case 0
    vals = zeros(3,1);
    vals(1) = detectF(Fx,v,eigv);
    %vals(1) = v(end);
    vals(2) = detectH(Fx,v,eigv);
    vals(3) = detectB(Fx,v,eigv);
    case 1
        %detect fold
        vals = detectF(Fx,v,eigv); %fold
        %vals = v(end);
    case 2
        %hopf
        vals = detectH(Fx,v,eigv);
    case 3
        %branch point
        vals = detectB(Fx,v,eigv);
end
end %end function

function c= detectF(Fx,v,eigv)
%c = v(end);
global curve;
c = det(Fx(1:curve.n,1:curve.n));
end

function c = detectB(Fx,v,eigv)
c = det([Fx;v']);
end

function pr = detectH(Fx,v,eigv)
pr = 1;
for i=1:length(eigv)
    for j=i+1:length(eigv)
        pr = pr*(eigv(i)+eigv(j));
    end
end
pr = real(pr);
end



% function [detected,ans0,ans1] = phi2(Fx0,v0,eig0,Fx1,v1,eig1)
% %detect hopf
% detected = false;
% [val0,ind0] = min(abs(real(eig0)));
% ans0 = eig0(ind0);
% [val1,ind1] = min(abs(real(eig1)));
% ans1 = eig1(ind1);
% 
% if ans0*ans1 < 0
%     e = eig0.*eig1;
%     v = find(e<0);
%     if length(v) == 2
%         detected = true;
%     end
% end
% end
% 
% function [detected,ans0,ans1] = phi3(Fx0,v0,eig0,Fx1,v1,eig1)
% %detect branch point
% detected = false;
% ans0 = det([Fx0;v0']);
% ans1 = det([Fx1;v1']);
% if ans0*ans1 < 0
%     detected = true;
% end
% end

function [u,p] = discx(x)
global copt;

u = x(1:copt.n);
p = copt.p;
p(copt.ap) = x(copt.n+1:end);
end

