function out = locateBP()

out{1} = @initBP;
out{2} = @fBP;
out{3} = @fderBP;

end

function y = initBP(x)
global copt;
lambda = x(end);
u = x(1:end-1);
p = copt.p;
p(copt.ap) = lambda;
jacu = calcjac(u,p);

[V,D] = eig(jacu');
mineig = Inf;
pos = 0;
for l = 1:size(D,1)
    val = abs(D(l,l));
    if  val < mineig
        mineig = val;
        pos = l;
    end
end
phi = V(:,pos);
phi = phi/psnorm(phi);
b = 0;
y = [u;lambda;b;phi];

end

function bp = fBP(y)
    global copt;
    [u,lambda,b,phi] = discy(y);
    
    bp = zeros(copt.n*2+2,1);
    
    p = copt.p;
    p(copt.ap) = lambda;
    
    fu = calcjac(u,p);
    fl = calcjacp(u,p,copt.ap);
    
    bp(1:copt.n) = copt.F(u,p) +b*phi;
    bp(copt.n+1:copt.n*2) = fu'*phi;
    bp(copt.n*2+1) = phi'*fl;
    bp(end) = phi'*phi -1;
    
end

function j = fderBP(x)
j = jacobian(@fBP,x);
end

function [u,lambda,b,phi] = discy(y)
global copt;
    u = y(1:copt.n);
    lambda = y(copt.n+1);
    b = y(copt.n+2);
    phi = y(copt.n+3:end);
end