function gpdemmpdePlotter(sol,tint,N,liveplot, pde,f,v,tid)
%sol solution structure
%tint is the interval which we want to compute solution points
%N is the number of internal points
%liveplot is boolean for weather we want to compute a liveplot
%tid is the time of the pause for the liveplot
% Evaluate and plot the solution at specified points.


% The mesh points at the ends of the interval are fixed, so x(0) = 0 and
% x(N+1) = 1.  The boundary values u(t,0) = 0 = a(0) and u(t,1) = 0 = a(N+1).
% Add these known values to the computed ones for the figures.
yint = deval(sol,tint);
%size(yint)
if pde
    if liveplot
    figure;
    color = 'r';
    max1=max(yint(1:N,1))+0.1;
    min1=min(yint(1:N,1))-0.1;
    for j = 1:length(tint)
    %-- create x and y values for plot (J.B.)
        solution  = [0; yint(1:N,j); 0];
        location  = [0; yint(N+1:end,j); 1];
    %-- plot the solution (J.B.)
        size(solution)
        size(location)
        ppp1=plot(location,solution,'r-o');
    %-- set several style options (J.B.)
           %set(ppp1,'LineWidth',2);
           axx1=get(gcf,'CurrentAxes');
           set(axx1,'FontSize',14);
           axis([0 1 min1 max1]);
    %-- print labels and title (J.B.)
        xlabel('x');
        ylabel('u');
        %titlestring=sprintf('Burgers equation u_t+u u_x= 0, t=%5.3f',tint(j));
         title(['t= ' num2str(tint(j))]);	
    %-- print file into png for movie creation (J.B.)
    %    file=sprintf('CLburger%4.4d',j);
    %    print('-dpng',file);
        if j==1
            pause
        else
            if tid ==0
                pause
            else
                pause(tid)
            end
        end
    end
    end %if liveplot

    drawnow

    % Plot the grid movement.
    figure
    ppp1 = plot(sol.x,sol.y(N+1:end,:));
    %set(ppp1,'LineWidth',2);
    %axx1=get(gcf,'CurrentAxes');
    %set(axx1,'FontSize',14);
    %xlabel('t-axis')
    %ylabel('x-axis')
    %title('Burgers equation. Grid trajectories')
else %no pde
    if liveplot
        figure;
        color = 'r';
        %max1=max(yint)+0.1;
        %min1=min(yint)-0.1;
        for j = 1:length(tint)
        %-- create x and y values for plot (J.B.)
            u = f{6}(tint(j),yint(:,j),v);
            solution  = [0; u; 0];
            location  = [0; yint(:,j); 1];
        %-- plot the solution (J.B.)
            ppp1=plot(location,solution,'r-o');
        %-- set several style options (J.B.)
               %set(ppp1,'LineWidth',2);
               %axx1=get(gcf,'CurrentAxes');
               %set(axx1,'FontSize',14);
               axis([0 1 0 1]);
        %-- print labels and title (J.B.)
            xlabel('x-axis');
            ylabel('solution u');
            title(['t=' num2str(tint(j))]);
            %titlestring=sprintf('Burgers equation u_t+u u_x= 0, t=%5.3f',tint(j));
            %title(titlestring)	
        %-- print file into png for movie creation (J.B.)
        %    file=sprintf('CLburger%4.4d',j);
        %    print('-dpng',file);
            if j==1
                pause
            else
                if tid ==0
                    pause
                else
                pause(tid)
                end
            end
        end
    end %if liveplot
    figure
    X0 = zeros(size(sol.x));
    X1 = ones(size(sol.x));
    ppp1 = plot(sol.x,[X0; sol.y ; X1]);
    %set(ppp1,'LineWidth',2);
    %axx1=get(gcf,'CurrentAxes');
    %set(axx1,'FontSize',14);
    xlabel('t-axis')
    ylabel('x-axis')
    drawnow;
end
