function out = clgspikes4

% Odefile of 1-d MMPDE5 model
%
out{1} = @init;
out{2} = @fun_eval;
out{3} = [];%@jacobian;
out{4} = [];%@jacobianp;
out{5} = [];%@hessians;
out{6} = [];%hessiansp;
out{7} = [];
out{8} = [];
out{9} = [];
% 
% --------------------------------------------------------------------------

function dxdt = fun_eval(t,x,t0,TAU,a1,a2,e1,e2,N,mmpdenumber,smooth)
libfile = MMPDELIB;
PDE = 0; %not PDE
x0 = 0;
xNP1 =1;
v = [a1,a2,e1,e2];
funct = gspikes4;

switch mmpdenumber
    case {4}
        M = feval(libfile{2},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    case {5}
        M = feval(libfile{3},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    case {6}
        M = feval(libfile{4},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    case {7}
        M = feval(libfile{5},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    otherwise
        disp('wrong mmpdenumber');
end
e = feval(libfile{6},t0,x,N,funct,v,TAU,smooth,PDE,x0,xNP1);%note that e= -E
dxdt = M\e; %M\ = inv(M)

% --------------------------------------------------------------------------

function [tspan,x0] = init(N,v)
tspan = [0; 1];
H = 0:1/(N+1):1;
funct = gspikes4;
x0 = feval(funct{7},H(2:end-1)',v);

