
function out = lorenz
    out{1} = @init;
    out{2} = @f;
    

%--------------------------------------------------

function [u0,p,ap] = init
    
    u0 = [0;0;0];
    sigma = 10;
    beta = 8/3;
    rho = 0;
    p = [sigma,rho,beta];
    ap = 2;


%--------------------------------------------------
%
% The vector field
%
function vf = f(u,p)
    x = u(1);
    y = u(2);
    z = u(3);
    sigma = p(1);
    rho = p(2);
    beta = p(3);

    vf = zeros(3,1);
    vf(1) = sigma*(y-x);
    vf(2) = rho*x - y - x*z;
    vf(3) = x*y-beta*z;

