function out = meshadapt
global copt;
% Odefile of 1-d MMPDE5 model
%
out{1} = @init;
out{2} = @fun_eval;
out{3} = [];%@jacobian;
out{4} = [];%@jacobianp;
out{5} = [];%@hessians;
out{6} = [];%hessiansp;
out{7} = [];
out{8} = [];
out{9} = [];
% 
% --------------------------------------------------------------------------

function dxdt = fun_eval(x,p)
t0 = p(1);
TAU = p(2);
a = p(3);
epsilon = p(4);
N = p(5);
mmpdenumber = p(6);
smooth = p(7);
libfile = MMPDELIB;
PDE = 0; %not PDE
x0 = 0;
xNP1 =1;
v = [a,epsilon];
funct = gspike;

switch mmpdenumber
    case {4}
        M = feval(libfile{2},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    case {5}
        M = feval(libfile{3},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    case {6}
        M = feval(libfile{4},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    case {7}
        M = feval(libfile{5},t0,x,N,funct,v,PDE,smooth,x0,xNP1);
    otherwise
        disp('wrong mmpdenumber');
end
e = feval(libfile{6},t0,x,N,funct,v,TAU,smooth,PDE,x0,xNP1);%note that e= -E
dxdt = M\e; %M\ = inv(M)

% --------------------------------------------------------------------------

function [x0,p,ap] = init()
N = 19; %the number of internal nodes 
H = 0:1/(N+1):1;
funct = gspike;
x0 = feval(funct{7},H(2:end-1)',v);
t0 = 0; %time
tau = 10^-4;
v = [0.30015 0.0121];%feval(funct{8});
a = v(1);
e = v(2);
mmpdenumber = 4;
smooth = 0; %boolean: smoothing?
p = [t0;tau;a;e;N;mmpdenumber;smooth];
