function j = jacobian(funct,x)
%approximate the Jacobian of a function F: R^(n+m) -> R^n
global copt;
   x1 = x; 
   x1(1) = x(1)-copt.jacincr; 
   x2 = x;
   x2(1) = x(1)+copt.jacincr;
   a = funct(x2) - funct(x1);
   
   if length(x) == 1
       j = a/(2*copt.jacincr);
   else
    j = zeros(length(a),length(x));
    j(:,1) = a;
    for i=2:length(x)
            x1 = x; 
            x1(i) = x1(i)-copt.jacincr;
            x2 = x; 
            x2(i) = x2(i)+copt.jacincr;
            j(:,i) = funct(x2) - funct(x1);
    end
    j = j/(2*copt.jacincr);
   end
end