function setOptions(opts,odefile)

global copt;

%default options

% options related to steplength adaption 
copt.h = 0.01;
copt.nominalContractionRate = 10^-3;
copt.nominalDist = 10^-4;
copt.nominalAngle = 10^-3;
copt.hinc = 1.3;
copt.hdec = 0.5;
copt.hmin = 10^-5; %minimum steplength
copt.hmax = 0.1;
copt.jacincr = 10^-5;

copt.pwu = 1;
copt.pwT = 1;
copt.pwl = 1;
copt.pwm = 0;

copt.numPoints = 50;

copt.orientation = 1; %or -1
copt.maxNewtIter = 20;
copt.maxBifIter = 20;
copt.correctortype = 0; %0 = gauss-newton, 1 = pseudo arclength, 2 = fastcont
copt.newteval = 0;
copt.singularityLocator = true;
%acceptance criterias
copt.toll = 10^-6;
copt.tolu = 10^-6;
copt.tolxinf = 10^-6;
copt.tolfinf = 10^-6;
copt.tolx = 10^-6;
copt.tolf = 10^-6;
copt.testtol = 10^-5;
copt.testsing = 10^-5;
copt.acceptanceCriteria = [1,1,0,0,0,0];
copt.detectBifurcationPoints = true;
copt.secanttangent = 0;
copt.printprogress = 0;

%options for limit cycle continuation
copt.ntst = 4;
copt.ncol = 3;

copt.odefile = odefile;
copt.initp = odefile{1};
copt.F = odefile{2};
%copt.usertest = odefile{3};

%copt.Fx = odefile{3};
%copt.Fp = odefile{4};

copt.jacincr = 10^-5;

names = fieldnames(opts);

%options for plotting
copt.plotstable = '-';
copt.plotunstable = ':';
copt.plotmarker = '*';
copt.plotcolor = 'k';
copt.plotcolormark = 'r';
copt.plotlinewidth = 1.5; %0.5

%options for mesh adaptation
copt.startadapt = 3;
copt.adaptmesh = 0; % 1 means moving mesh adaptation
copt.mmpde = 5; %mmpde5, valid numbers 4-7..
copt.meshrelaxation = 10^-4; %relaxation constant for moving mesh algorithms
copt.smoothing = 0; %0 = off, 1= on
copt.meshtol = 10^-5;

for i=1:length(names)
    label = char(names(i));
    if isfield(copt,label)
        optsfield = getfield(opts,label);
        copt = setfield(copt,label,optsfield);
    end
end




